module Oztogo
  class Base

    include HTTParty

    def initialize(method, path)
      ensure_api_key
      request(method, path)
    end

    def api_endpoint
      'https://api.navitia.io/v1/'
    end

    def api_key
      ENV['NAVITIA_API_KEY']
    end

    private

    def ensure_api_key; raise Oztogo::OztogoError, 'API key missing' unless api_key; end

    def request(method, path)
      url = api_endpoint + path
      self.class.send("#{method}", url, connection_options)
    end

    def connection_options
      {
        basic_auth: { username: api_key },
        user_agent: 'Oztogo'
      }
    end
  end
end