module Oztogo
  class SearchJourney < Base

    def initialize(params = {})
      @response = request('get', path(params))
    end

    def path(params)
      params = prepare_query_string(params)
      region = params.delete(:region)
      raise Oztogo::OztogoError, 'You must provide a region' if region.nil?
      "coverage/#{region}/journeys?#{build_params_string(params)}"
    end

    def prepare_query_string(params)
      params[:datetime] ||= DateTime.now.strftime('%Y%m%dT%H%M')
      params[:min_nb_journeys] ||= 3
      params
    end

    def build_params_string(params)
      params.map{ |k, v| "#{k}=#{v}" }.join('&')
    end

    def journeys
      @journeys = []
      @response['journeys'].each do |j|
        @journeys << Oztogo::Journey.new(j)
      end
      @journeys
    end
  end
end
